Welcome to Subscribe On Youtube
2865. Beautiful Towers I
Description
You are given a 0indexed array maxHeights
of n
integers.
You are tasked with building n
towers in the coordinate line. The i^{th}
tower is built at coordinate i
and has a height of heights[i]
.
A configuration of towers is beautiful if the following conditions hold:
1 <= heights[i] <= maxHeights[i]
heights
is a mountain array.
Array heights
is a mountain if there exists an index i
such that:
 For all
0 < j <= i
,heights[j  1] <= heights[j]
 For all
i <= k < n  1
,heights[k + 1] <= heights[k]
Return the maximum possible sum of heights of a beautiful configuration of towers.
Example 1:
Input: maxHeights = [5,3,4,1,1] Output: 13 Explanation: One beautiful configuration with a maximum sum is heights = [5,3,3,1,1]. This configuration is beautiful since:  1 <= heights[i] <= maxHeights[i]  heights is a mountain of peak i = 0. It can be shown that there exists no other beautiful configuration with a sum of heights greater than 13.
Example 2:
Input: maxHeights = [6,5,3,9,2,7] Output: 22 Explanation: One beautiful configuration with a maximum sum is heights = [3,3,3,9,2,2]. This configuration is beautiful since:  1 <= heights[i] <= maxHeights[i]  heights is a mountain of peak i = 3. It can be shown that there exists no other beautiful configuration with a sum of heights greater than 22.
Example 3:
Input: maxHeights = [3,2,5,5,2,3] Output: 18 Explanation: One beautiful configuration with a maximum sum is heights = [2,2,5,5,2,2]. This configuration is beautiful since:  1 <= heights[i] <= maxHeights[i]  heights is a mountain of peak i = 2. Note that, for this configuration, i = 3 can also be considered a peak. It can be shown that there exists no other beautiful configuration with a sum of heights greater than 18.
Constraints:
1 <= n == maxHeights <= 10^{3}
1 <= maxHeights[i] <= 10^{9}
Solutions
Solution 1: Enumeration
We can enumerate each tower as the tallest tower, each time expanding to the left and right, calculating the height of each other position, and then accumulating to get the height sum $t$. The maximum of all height sums is the answer.
The time complexity is $O(n^2)$, and the space complexity is $O(1)$. Here, $n$ is the length of the array $maxHeights$.
Solution 2: Dynamic Programming + Monotonic Stack
Solution 1 is sufficient to pass this problem, but the time complexity is relatively high. We can use “Dynamic Programming + Monotonic Stack” to optimize the enumeration process.
We define $f[i]$ to represent the height sum of the beautiful tower scheme with the last tower as the tallest tower among the first $i+1$ towers. We can get the following state transition equation:
\[f[i]= \begin{cases} f[i1]+heights[i],&\text{if } heights[i]\geq heights[i1]\\ heights[i]\times(ij)+f[j],&\text{if } heights[i]<heights[i1] \end{cases}\]Where $j$ is the index of the first tower to the left of the last tower with a height less than or equal to $heights[i]$. We can use a monotonic stack to maintain this index.
We can use a similar method to find $g[i]$, which represents the height sum of the beautiful tower scheme from right to left with the $i$th tower as the tallest tower. The final answer is the maximum value of $f[i]+g[i]heights[i]$.
The time complexity is $O(n)$, and the space complexity is $O(n)$. Here, $n$ is the length of the array $maxHeights$.

class Solution { public long maximumSumOfHeights(List<Integer> maxHeights) { long ans = 0; int n = maxHeights.size(); for (int i = 0; i < n; ++i) { int y = maxHeights.get(i); long t = y; for (int j = i  1; j >= 0; j) { y = Math.min(y, maxHeights.get(j)); t += y; } y = maxHeights.get(i); for (int j = i + 1; j < n; ++j) { y = Math.min(y, maxHeights.get(j)); t += y; } ans = Math.max(ans, t); } return ans; } }

class Solution { public: long long maximumSumOfHeights(vector<int>& maxHeights) { long long ans = 0; int n = maxHeights.size(); for (int i = 0; i < n; ++i) { long long t = maxHeights[i]; int y = t; for (int j = i  1; ~j; j) { y = min(y, maxHeights[j]); t += y; } y = maxHeights[i]; for (int j = i + 1; j < n; ++j) { y = min(y, maxHeights[j]); t += y; } ans = max(ans, t); } return ans; } };

class Solution: def maximumSumOfHeights(self, maxHeights: List[int]) > int: ans, n = 0, len(maxHeights) for i, x in enumerate(maxHeights): y = t = x for j in range(i  1, 1, 1): y = min(y, maxHeights[j]) t += y y = x for j in range(i + 1, n): y = min(y, maxHeights[j]) t += y ans = max(ans, t) return ans

func maximumSumOfHeights(maxHeights []int) (ans int64) { n := len(maxHeights) for i, x := range maxHeights { y, t := x, x for j := i  1; j >= 0; j { y = min(y, maxHeights[j]) t += y } y = x for j := i + 1; j < n; j++ { y = min(y, maxHeights[j]) t += y } ans = max(ans, int64(t)) } return } func min(a, b int) int { if a < b { return a } return b } func max(a, b int64) int64 { if a > b { return a } return b }

function maximumSumOfHeights(maxHeights: number[]): number { let ans = 0; const n = maxHeights.length; for (let i = 0; i < n; ++i) { const x = maxHeights[i]; let [y, t] = [x, x]; for (let j = i  1; ~j; j) { y = Math.min(y, maxHeights[j]); t += y; } y = x; for (let j = i + 1; j < n; ++j) { y = Math.min(y, maxHeights[j]); t += y; } ans = Math.max(ans, t); } return ans; }